package sample;

import javafx.application.Application;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.stage.Stage;
import javafx.animation.AnimationTimer;

public class Main extends Application {
    Ball ball;
    Bat batL;

    int lPoints, rPoints;
    Label score;

    float width, height;

    @Override
    public void start(Stage primaryStage) throws Exception{
        // this

        width = 600;
        height = 400;

        Group root = new Group();
        Scene scene = new Scene(root, width, height);

        primaryStage.setTitle("PONG");
        primaryStage.setScene(scene);
        primaryStage.show();

        score = new Label(lPoints+":"+rPoints);
        score.setLayoutX(width/2);
        root.getChildren().add(score);

        // initialisiere Objekte: ball
        ball = new Ball(width/2,height/2,25, this);
        ball.addTo(root);

        batL = new Bat(0,0,10,50);
        batL.addTo(root);

        new AnimationTimer() {
            public void handle (long currentNanoTime) {
                // game loop
                ball.move();
                batL.move();

            }
        }.start();

        // Tasten Eingabe
        scene.setOnKeyPressed(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent event) {
                System.out.println(event.getCode());
                if (event.getCode() == KeyCode.W) {
                    batL.dy = -1;
                }
                if (event.getCode() == KeyCode.S) {
                    batL.dy = 1;
                }
            }
        });
        scene.setOnKeyReleased(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent event) {
                System.out.println(event.getCode());
                if (event.getCode() == KeyCode.W || event.getCode() == KeyCode.S) {
                    batL.dy = 0;
                }
            }
        });
    }

    public void updateScore () {
        score.setText(lPoints+":"+rPoints);
    }


    public static void main(String[] args) {
        launch(args);
    }
}